Skip to content

Connectivity Edge Query.

POST
/api/data/namespaces/{namespace}/graph/connectivity/edge
curl --request POST \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/data/namespaces/example/graph/connectivity/edge \
--header 'Authorization: <Authorization>' \
--header 'Content-Type: application/json' \
--data '{ "dst_id": { "site": "example", "site_type": "INVALID" }, "end_time": "example", "field_selector": { "healthscore": { "types": [ "HEALTHSCORE_NONE" ] }, "metric": { "features": [ "TIMESERIES_FEATURE_NONE" ], "types": [ "EDGE_METRIC_TYPE_NONE" ] } }, "namespace": "example", "range": "example", "src_id": { "site": "example", "site_type": "INVALID" }, "start_time": "example", "step": "example" }'

Request to GET Connectivity data for an edge. This query is used to GET time-series data for a given edge.

namespace
required
string

Namespace This request is supported only in system namespace.

Media typeapplication/json
Connectivity Edge Request

Request to GET the time-series data for an edge in the connectivity graph. While graph/connectivity API is used to GET connectivity data for all sites, where each node and edge contains the aggregated value for each field; graph/connectivity/edge API is used to GET the time-series data (drill-down of aggregated data) for each field.

object
dst_id
object
site
Site

Name of the site.

string
<= 1024 characters
site_type
string
default: INVALID
Allowed values: INVALID REGIONAL_EDGE CUSTOMER_EDGE NGINX_ONE
end_time
end_time

End time of metric collection from which data will be considered to build graph. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the end_time will be evaluated to start_time+10m If start_time is not specified, then the end_time will be evaluated to

string
<= 1024 characters
field_selector
object
healthscore
object
types
Types

Healthscore types to be returned in the response.

Array<string>
Allowed values: HEALTHSCORE_NONE HEALTHSCORE_CONNECTIVITY HEALTHSCORE_PERFORMANCE HEALTHSCORE_SECURITY HEALTHSCORE_RELIABILITY HEALTHSCORE_OVERALL
metric
object
features
Features

Specify list of timeseries features that should be returned for each metric type in the request.

Array<string>
Allowed values: TIMESERIES_FEATURE_NONE CONFIDENCE_INTERVAL ANOMALY_DETECTION TREND HEALTHSCORE
types
Types

Specify list of metrics that should be returned for each edge in the connectivity graph.

Array<string>
Allowed values: EDGE_METRIC_TYPE_NONE EDGE_REACHABILITY EDGE_LATENCY EDGE_IN_THROUGHPUT EDGE_OUT_THROUGHPUT EDGE_IN_DROP_RATE EDGE_OUT_DROP_RATE EDGE_CONNECTION_STATUS EDGE_ARES_CONNECTION_STATUS EDGE_DATA_PLANE_CONNECTION_STATUS EDGE_CONTROL_PLANE_CONNECTION_STATUS
namespace
namespace

This request is supported only in system namespace.

string
>= 6 characters <= 1024 characters
range
range

Range decides how far to go back in time to fetch values for each step. For example, if the range is 5m, then for step t1, query will be evaluated for t1-5m and for t2, query will be evaluated for t2-5m and so on. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days

Note: For non-timeseries query, i.e., for step=end_time-start_time, range should be set to end_time-start_time

Optional: If not specified, range is set to 5m.

string
<= 1024 characters
src_id
object
site
Site

Name of the site.

string
<= 1024 characters
site_type
string
default: INVALID
Allowed values: INVALID REGIONAL_EDGE CUSTOMER_EDGE NGINX_ONE
start_time
start_time

Start time of metric collection from which data will be considered to build graph. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the start_time will be evaluated to end_time-10m If end_time is not specified, then the start_time will be evaluated to -10m.

string
<= 1024 characters
step
step

Step is the resolution width, which determines the number of the data points [x-axis (time)] to be returned in the response. The timestamps in the response will be t1=start_time, t2=t1+step, … Tn=tn-1+step, where tn <= end_time. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days

Optional: If not specified, then step size is evaluated to <end_time - start_time>

string
<= 1024 characters

A successful response.

Media typeapplication/json
Connectivity Edge Response

Response for graph/connectivity/edge API returns the time-series data for the edge specified in the request.

object
data
object
dst_id
object
site
Site

Name of the site.

string
<= 1024 characters
site_type
string
default: INVALID
Allowed values: INVALID REGIONAL_EDGE CUSTOMER_EDGE NGINX_ONE
healthscore
object
data
Data

List of healthscores specified in the request.

Array<object>
Healthscore Type Data

HealthScoreTypeData contains healthscore type and the corresponding value.

object
reason
Reason

A human readable string explaining the reason in case of bad healthscore.

string
>= 27 characters <= 1024 characters
type
string
default: HEALTHSCORE_NONE
Allowed values: HEALTHSCORE_NONE HEALTHSCORE_CONNECTIVITY HEALTHSCORE_PERFORMANCE HEALTHSCORE_SECURITY HEALTHSCORE_RELIABILITY HEALTHSCORE_OVERALL
value
Value

Healthscore value.

Array<object>
>= 3 characters <= 15 characters
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
metric
Metric

Edge Metric data specified in the request.

Array<object>
Edge Metric Data

EdgeMetricData contains the metric type and the corresponding metric value.

object
type
string
default: EDGE_METRIC_TYPE_NONE
Allowed values: EDGE_METRIC_TYPE_NONE EDGE_REACHABILITY EDGE_LATENCY EDGE_IN_THROUGHPUT EDGE_OUT_THROUGHPUT EDGE_IN_DROP_RATE EDGE_OUT_DROP_RATE EDGE_CONNECTION_STATUS EDGE_ARES_CONNECTION_STATUS EDGE_DATA_PLANE_CONNECTION_STATUS EDGE_CONTROL_PLANE_CONNECTION_STATUS
unit
string
default: UNIT_MILLISECONDS
Allowed values: UNIT_MILLISECONDS UNIT_SECONDS UNIT_MINUTES UNIT_HOURS UNIT_DAYS UNIT_BYTES UNIT_KBYTES UNIT_MBYTES UNIT_GBYTES UNIT_TBYTES UNIT_KIBIBYTES UNIT_MIBIBYTES UNIT_GIBIBYTES UNIT_TEBIBYTES UNIT_BITS_PER_SECOND UNIT_BYTES_PER_SECOND UNIT_KBITS_PER_SECOND UNIT_KBYTES_PER_SECOND UNIT_MBITS_PER_SECOND UNIT_MBYTES_PER_SECOND UNIT_CONNECTIONS_PER_SECOND UNIT_ERRORS_PER_SECOND UNIT_PACKETS_PER_SECOND UNIT_REQUESTS_PER_SECOND UNIT_PACKETS UNIT_PERCENTAGE UNIT_COUNT
value
object
anomaly
Anomaly

Number of anomalies for the given time range.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
confidence_lower_bound
Confidence Lower Bound

Lower Bound of the metric value.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
confidence_upper_bound
Confidence Upper Bound

Upper Bound of the metric value.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
healthscore
Healthscore

Healscore of the metric calculated based on the number of anomalies and the value of the anomalies for the time range.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
raw
Raw

List of metric values for a given metric type.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
trend
Trend

Indicates the metric trend.

Array<object>
Metric Value

Each metric value consists of a timestamp and a value. Timestamp in the Metric Value is based on the start_time, end_time and step in the request. Valid values for timestamp are t1=start_time, t2=t1+step, t3=t2+step, … Tn=tn-1+step, where tn <= end_time. Response may not contain values for all timestamps between start_time and end_time.

object
timestamp
Timestamp

UTC timestamp in seconds.

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Metric value.

string
>= 3 characters <= 1024 characters
src_id
object
site
Site

Name of the site.

string
<= 1024 characters
site_type
string
default: INVALID
Allowed values: INVALID REGIONAL_EDGE CUSTOMER_EDGE NGINX_ONE
step
step

Actual step size used in the response. It could be higher than the requested step due to metric rollups and the query duration. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days.

string
<= 1024 characters
Example
{
"data": {
"dst_id": {
"site_type": "INVALID"
},
"healthscore": {
"data": [
{
"type": "HEALTHSCORE_NONE",
"value": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
]
}
]
},
"metric": [
{
"type": "EDGE_METRIC_TYPE_NONE",
"unit": "UNIT_MILLISECONDS",
"value": {
"anomaly": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"confidence_lower_bound": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"confidence_upper_bound": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"healthscore": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"raw": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
],
"trend": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
]
}
}
],
"src_id": {
"site_type": "INVALID"
}
}
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example